// PDO_MultiDataDlg.cpp : @
//

#include "stdafx.h"
#include "PDO_MultiData.h"
#include "PDO_MultiDataDlg.h"
#include "..\..\lib\i8123w.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CPDO_MultiDataDlg ܤ

CPDO_MultiDataDlg::CPDO_MultiDataDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPDO_MultiDataDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPDO_MultiDataDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_LIST_PDOLIST, m_pdolist);
	DDX_Control(pDX, IDC_COMBO_SLOT, m_slot);
	DDX_Control(pDX, IDC_COMBO_NODE, m_node);
	DDX_Control(pDX, IDC_COMBO_BAUD, m_baud);
	DDX_Control(pDX, IDC_BUTTON_SHUTDOWN, m_btn_shutdown);
	DDX_Control(pDX, IDC_BUTTON_SETTIMER, m_btn_settimer);
	DDX_Control(pDX, IDC_BUTTON_SETPOLLING, m_btn_setpolling);
	DDX_Control(pDX, IDC_BUTTON_REMOVE, m_btn_removenode);
	DDX_Control(pDX, IDC_BUTTON_INITIAL, m_btn_initial);
	DDX_Control(pDX, IDC_BUTTON_ADDNODE, m_btn_addnode);
}

BEGIN_MESSAGE_MAP(CPDO_MultiDataDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	ON_CBN_SELCHANGE(IDC_COMBO_SLOT, OnSelchangeComboSlot)
	ON_CBN_SELCHANGE(IDC_COMBO_BAUD, OnSelchangeComboBaud)
	ON_CBN_SELCHANGE(IDC_COMBO_NODE, OnSelchangeComboNode)
	ON_BN_CLICKED(IDC_BUTTON_INITIAL, OnButtonInitial)
	ON_BN_CLICKED(IDC_BUTTON_SHUTDOWN, OnButtonShutdown)
	ON_BN_CLICKED(IDC_BUTTON_ADDNODE, OnButtonAddnode)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_BN_CLICKED(IDC_BUTTON_SETTIMER, OnButtonSettimer)
	ON_BN_CLICKED(IDC_BUTTON_SETPOLLING, OnButtonSetpolling)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CPDO_MultiDataDlg TBz`
BYTE SLOT=0;
BYTE BAUD=0;
BYTE NODE=1;

BYTE BlockMode = 1;

WORD Id_List[10] = {0};
BYTE PDO_Cnt = 0;

WORD DelayTime=0;
WORD ret;
CString errstr;

void CPDO_MultiDataDlg::Enable_Disable(bool Sta)
{
	if(Sta == FALSE){
		m_btn_setpolling.EnableWindow(FALSE);
		m_btn_settimer.EnableWindow(FALSE);
	}
	else{
		m_btn_setpolling.EnableWindow(TRUE);
		m_btn_settimer.EnableWindow(TRUE);
	}
}

BOOL CPDO_MultiDataDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ]wܤϥܡCε{DOܤɡA
	// ج[|۰ʱqƦ@~
	SetIcon(m_hIcon, TRUE);			// ]wjϥ
	SetIcon(m_hIcon, FALSE);		// ]wpϥ

	// TODO: b[JB~l]w
	m_slot.EnableWindow(TRUE);
	m_baud.EnableWindow(TRUE);
	m_node.EnableWindow(FALSE);

	m_btn_initial.EnableWindow(TRUE);
	m_btn_addnode.EnableWindow(FALSE);

	Enable_Disable(FALSE);

	for(WORD i = 0;i< 8;i++){
		CString str;

		str.Format(_T("%d"),i);
		m_slot.AddString(str);
	}

	for(WORD i = 1;i< 128;i++){
		CString str;

		if(i < 10) str.Format(_T("    %d"),i);
		else if(i < 100) str.Format(_T("  %d"),i);
		else str.Format(_T("%d"),i);
		
		m_node.AddString(str);
	}

	{
		m_baud.AddString(_T("    10 kbps"));
		m_baud.AddString(_T("    20 kbps"));
		m_baud.AddString(_T("    50 kbps"));
		m_baud.AddString(_T("  125 kbps"));
		m_baud.AddString(_T("  250 kbps"));
		m_baud.AddString(_T("  500 kbps"));
		m_baud.AddString(_T("  800 kbps"));
		m_baud.AddString(_T("1000 kbps"));
	}

	m_slot.SetCurSel(0);
	m_baud.SetCurSel(0);
	m_node.SetCurSel(0);

	return TRUE;  // Ǧ^ TRUEADzﱱ]wJI
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CPDO_MultiDataDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_PDO_MULTIDATA_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_PDO_MULTIDATA_DIALOG));
	}
}
#endif


void CPDO_MultiDataDlg::OnSelchangeComboSlot() 
{
	// TODO: Add your control notification handler code here
	SLOT = m_slot.GetCurSel();
}

void CPDO_MultiDataDlg::OnSelchangeComboBaud() 
{
	// TODO: Add your control notification handler code here
	BAUD = m_baud.GetCurSel();

	switch(BAUD){
	case 0:
		DelayTime = 15;
		break;
	case 1:
		DelayTime = 7;
		break;
	case 2:
		DelayTime = 3;
		break;
	case 3:
	case 4:
		DelayTime = 1;
		break;
	case 5:
	case 6:
	case 7:
		DelayTime = 0;
		break;
	}
}

void CPDO_MultiDataDlg::OnSelchangeComboNode() 
{
	// TODO: Add your control notification handler code here
	NODE = m_node.GetCurSel()+1;
}

void CPDO_MultiDataDlg::OnButtonInitial() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_InitMaster(SLOT, 0, BAUD, BlockMode);
	if(ret){
		errstr.Format(_T("Initial Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_slot.EnableWindow(FALSE);
		m_baud.EnableWindow(FALSE);
		m_node.EnableWindow(TRUE);

		m_btn_initial.ShowWindow(SW_HIDE);
		m_btn_addnode.EnableWindow(TRUE);
	}
}

void CPDO_MultiDataDlg::OnButtonShutdown() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_ShutdownMaster(SLOT);
	if(ret){
		errstr.Format(_T("Shutdown Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_slot.EnableWindow(TRUE);
		m_baud.EnableWindow(TRUE);
		m_node.EnableWindow(FALSE);

		m_btn_initial.ShowWindow(SW_SHOW);

		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_SHOW);
		m_btn_removenode.EnableWindow(FALSE);

		m_node.SetCurSel(0);

		Enable_Disable(FALSE);

		KillTimer(123);
	}
}

void CPDO_MultiDataDlg::OnButtonAddnode() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_AddNode(SLOT, NODE, 1, DelayTime, 200, BlockMode);
	if(ret){
		errstr.Format(_T("AddNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_HIDE);
		m_btn_removenode.EnableWindow(TRUE);

		m_node.EnableWindow(FALSE);

		ret = I8123_GetTxPDOID(SLOT, NODE, &PDO_Cnt, Id_List, BlockMode);
        if (ret != 0){
			errstr.Format(_T("GetTxPDOID Error, = %d"),ret);
            MessageBox(errstr,_T("Error"),MB_OK);

            Enable_Disable(FALSE);
        }
		else{
			Enable_Disable(TRUE);

            SetTimer(123, 100, NULL);
        }
	}
}

void CPDO_MultiDataDlg::OnButtonRemove() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_RemoveNode(SLOT, NODE, BlockMode);
	if(ret){
		errstr.Format(_T("RemoveNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_btn_addnode.EnableWindow(TRUE);
		m_btn_addnode.ShowWindow(SW_SHOW);
		m_btn_removenode.EnableWindow(FALSE);

		Enable_Disable(FALSE);

		KillTimer(123);
	}
}

void CPDO_MultiDataDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	I8123_ShutdownMaster(SLOT);
}

void CPDO_MultiDataDlg::OnButtonSettimer() 
{
	WORD i;

	// TODO: Add your control notification handler code here
    ret = I8123_SetPDORemotePolling(SLOT, 0, NULL, 500, BlockMode);  // Remove PDO-Polling 
    if (ret != 0){
		errstr.Format(_T("Stop TxPDO Polling Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
    }

    for (i = 0; i < PDO_Cnt; i++){
		ret = I8123_PDOEventTimer(SLOT, Id_List[i], 500, BlockMode);
		if (ret != 0){
			errstr.Format(_T("The PDO %03X Not Support Event Timer"),Id_List[i]);
			MessageBox(errstr,_T("Error"),MB_OK);
        }
    }
}

void CPDO_MultiDataDlg::OnButtonSetpolling() 
{
	WORD i;

	// TODO: Add your control notification handler code here
	for (i = 0; i < PDO_Cnt; i++){
		ret = I8123_PDOEventTimer(SLOT, Id_List[i], 0, BlockMode);  // Stop PDO Event Timer
        if (ret != 0){
			errstr.Format(_T("Stop The PDO %03X Event Timer Error, = %d"),Id_List[i],ret);
			MessageBox(errstr,_T("Error"),MB_OK);
        }
    }

    ret = I8123_SetPDORemotePolling(SLOT, PDO_Cnt, Id_List, 500, BlockMode);
    if (ret != 0){
		errstr.Format(_T("Set Polling All TxPDO Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
    }
}

void CPDO_MultiDataDlg::OnTimer(UINT nIDEvent) 
{
	WORD i, j;
    CString Temp_Str;

	BYTE *IsNew;
	BYTE *DLen;
	BYTE *Data;

	// TODO: Add your message handler code here and/or call default
	if(PDO_Cnt){
		IsNew = (BYTE*) malloc(PDO_Cnt);
		DLen = (BYTE*) malloc(PDO_Cnt);
		Data = (BYTE*) malloc(8 * PDO_Cnt);

		if((IsNew == NULL) || (DLen == NULL) || (Data == NULL)) return;

		memset(IsNew, 0, PDO_Cnt);
		memset(DLen, 0, PDO_Cnt);
		memset(Data, 0, 8 * PDO_Cnt);

		ret = I8123_GetMultiPDOData(SLOT, PDO_Cnt, Id_List, IsNew, DLen, Data, 0);
		if (ret == 0){
			WORD startaddr = 0;

			m_pdolist.ResetContent();

			for (i = 0; i < PDO_Cnt; i++){
				Temp_Str.Format(_T("TxPDO %X : "),Id_List[i]);
				startaddr = (WORD)(i * 8);

				for (j = 0; j < DLen[i]; j++){
					Temp_Str.Format(_T("%s%02X "),Temp_Str, Data[startaddr + j]);
				}

				m_pdolist.AddString(Temp_Str);
			}
		}

		free(IsNew);
		free(DLen);
		free(Data);
	}

	CDialog::OnTimer(nIDEvent);
}
